unit RASComboBox;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, shellapi;

type
  TRASComboBox = class(TComboBox)
  private
     rasliste: TStrings;   {Behelfs-Liste}

  protected
     procedure CreateWnd; override;

  public
     constructor Create(AOwner: TComponent);override;
     procedure Start;

  published

  end;

procedure Register;


implementation

procedure Register;
begin
  RegisterComponents('SteGaSoft', [TRASComboBox]);
end;

{**** Funktion zur Ermittlung des System-Verzeichnisses  ****}
function GetSysDir: String;
var p: PChar;
begin
 p:=StrAlloc(MAX_PATH+1);
 GetSystemDirectory(p, MAX_PATH+1);
 result:=p;
 StrDispose(p)
end;
{*********************************************************}

constructor TRASComboBox.Create(AOwner: TComponent);
begin
inherited create(AOwner);
Style:=csDropDownList;
end;

{ Hier wird rasphone.pbk ausgelesen, gefiltert und in die ComboBox eingetragen }
procedure TRASComboBox.CreateWnd;
var syspfad, zeile, zeichen: String;
    zeilzahl, i, zeichenzahl: Integer;
begin
inherited CreateWnd;
Items.Clear;
syspfad:=GetSysDir;
rasliste:=TStringlist.Create;
rasliste.LoadFromFile(syspfad+'\ras\rasphone.pbk');
zeilzahl:=rasliste.Count;

for i:=0 to zeilzahl-1 do
 begin
 if rasliste[i]='' then zeile:=' '
 else zeile:=rasliste[i];
 zeichen:=zeile[1];
  if zeichen='[' then
  begin
  zeichenzahl:= length(zeile);
  Items.Add(copy(zeile,2,zeichenzahl-2));
  end;
end;
ItemIndex:=0;
end;
{**************************************************}

{*** Prozedur zum Starten von rasphone.exe ****}
procedure TRASComboBox.Start;
var parameter, syspfad: String;
begin
syspfad:=GetSysDir;
parameter:=' /d "'+Text+'"';
ShellExecute(TRasCombobox(Self).Handle, 'open', 'rasphone.exe',PChar(parameter), PChar(syspfad), SW_SHOWNORMAL);
end;
{***********************************************}

end.
