unit RASStart;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ShellApi;

type
  TRASStart = class(TComponent)
  private
    FStartNr: Integer;  {Welchen Listeneintrag starten? Liste Beginnt mit 0 !}
    liste1: TStrings;   {Behelfs-Liste}

    procedure SetStartNr(Value: Integer);

  protected

  public
    RASEintrag: TStrings; {Hier stehen alle in rasphone.pbk def. Eintrge}
    constructor Create(AOwner: TComponent);override;
    procedure Start;
  published
    property StartNr: Integer read FStartNr write SetStartNr;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('SteGaSoft', [TRASStart]);
end;

{**** Funktion zur Ermittlung des System-Verzeichnisses ****}
function GetSysDir: String;
var p: PChar;
begin
p:=StrAlloc(MAX_PATH+1);
GetSystemDirectory(p, MAX_PATH+1);
result:=p;
StrDispose(p);
end;
{****************************************************}

{*** Komponente wird erstellt und Eintrge aus rasphone.pbk ausgelesen ***}
constructor TRASStart.Create(AOwner: TComponent);
var syspfad, zeile, zeichen, parameter: String;
    zeilzahl, zeichzahl, i: Integer;
begin
inherited create(AOwner);
syspfad:=GetSysDir;
liste1:=TStringList.Create;
RASEintrag:=TStringList.Create;
liste1.Clear;
RASEintrag.Clear;
liste1.LoadFromFile(syspfad+'\ras\rasphone.pbk');
zeilzahl:=liste1.Count;
for i:=0 to zeilzahl-1 do
 begin
 if liste1[i]='' then zeile:=' '
 else zeile:=liste1[i];

 zeichen:=zeile[1];
 if zeichen='[' then
  begin
  zeichzahl:=Length(zeile);
  RASEintrag.Add(copy(zeile,2,zeichzahl-2));
  end;
 end;
end;
{*******************************************************}

procedure TRASStart.SetStartNr(Value: Integer);
begin
FStartNr:=Value;
end;

{**** Prozedur zum starten von rasphone.exe ****}
procedure TRASStart.Start;
var syspfad, parameter: String;
begin
syspfad:=GetSysDir;
parameter:=' /d "'+RASEintrag[FStartNr]+'"';
ShellExecute(Application.handle,'open', 'rasphone.exe',PChar(parameter),
                                                PChar(syspfad), SW_SHOWNORMAL);
end;
{************************************************}
end.
 